/* forkexec.c, Hans-Georg Esser, Systemprogrammierung */

#include <stdio.h>
#include <unistd.h>

int main () {
  pid_t pid1, pid2, pid3;

  printf ("Start\n");
  pid1 = fork();              /* fork 1 */
  printf ("Nach fork 1\n");
  if (pid1==0) {
    execlp ("echo","echo","echo-test",NULL);
    printf ("Nach exec\n");
  } else {
    pid2 = fork();            /* fork 2 */
    printf ("Nach fork 2\n");
    pid3 = fork();            /* fork 3 */
    if ((pid2 == 0) && (pid3 ==0)) {
      printf ("pid1 != 0, pid2=pid3=0\n");
    };
  };
  printf ("Prozessende; pid1=%d, pid2=%d, pid3=%d\n", pid1, pid2, pid3);
  if ((pid1 != 0) && (pid2 != 0) && (pid3 != 0)) {
    /* urspruenglicher Prozess */
    sleep(1);
    printf ("Programmende\n");
  };
  return 0;
}

